###
###
#
# Global definitions for Makefiles.
# This file is included by all TAGL Makefiles.
# Modify it according to your system.
# or get the right makefile.inc in the config 
# directory.
#
###
###

#
# Configuration:
# g++
# X11 XShm, Solaris
#
#


# TAGL distribution tree

  TAGL_ROOT = $(HOME)/tagl21/
  TAGL_INC  = $(TAGL_ROOT)include/
  TAGL_LIB  = $(TAGL_ROOT)lib/
  TAGL_BIN  = $(TAGL_ROOT)bin/

  TAGL_ROOT2  = $(TAGL_ROOT)
  TAGL_INC2   = $(TAGL_INC)
  TAGL_LIB2   = $(TAGL_LIB)
  TAGL_BIN2   = $(TAGL_BIN)

# C and C++ compiler

  CXX=g++
  CC=gcc
  LDXX=g++
  LD=gcc

# Unix commands


  RM=rm -f
  CP=cp
  MV=mv

# dependancies file name
# I don't know why, but my dependancy file is not
# recognized under DOS.


  DEP = $(TAGL_ROOT)config/dummy.dep


# optimize flags

OPTIMIZE=-O6 -funroll-loops

# X11 and SVGA special stuff.
# Add here include and linking path if needed.
# Remove -DX_SHM if your system does not have MIT X SHM.
# Remove -lvga if you don't have Linux SVGAlib.


# These flags did work on the solaris box I can access.
# It may be different on yours ...

  CCX11=-DX_SHM -I/usr/local/X11/include
  LDX11=-R/usr/local/X11/lib -L/usr/local/X11/lib -lX11 -lXext -lsocket -lnsl

  CCSVGA=
  LDSVGA=

# Add -DEBUG here for compiling
# assertion checks (slower).

CCOPT=$(OPTIMIZE)
CXXOPT=$(OPTIMIZE)

LDOPT=
LDXXOPT=-lm

# Remove SVGAgport if you don't have Linux SVGAlib.
# Remove Xgport if you only have Linux SVGAlib.
# If you develop polygon engines, add them here.

USEGPORTS   = Xgport 
USEPOLYENGS = peng_8 peng_555 peng_565 peng_24 peng_32x peng_x32

# You should not need to modify these lines.
# See next comment ...

SRCGPORTS   = $(USEGPORTS:%=%.cc)
SRCPOLYENGS = $(USEPOLYENGS:%=%.cc)

GPORTS      = $(USEGPORTS:%=%.o)
POLYENGS    = $(USEPOLYENGS:%=%.o)

LDGPORTS    = $(GPORTS:%=$(TAGL_LIB)%)
LDPOLYENGS  = $(POLYENGS:%=$(TAGL_LIB)%)

           
# If your 'make' utility doesn't accept the previous decl,
# remove the previous declaration, uncomment the following
# ones, and remove the stuff you don't use from it.
# You can also change your 'make' command ( the one distributed with
# djgpp works well ... )
# I sincerely hope your 'make' supports it !!
#
#SRCGPORTS=Xgport.C SVGAgport.C
#SRCPOLYENGS=polyeng_8.C polyeng_555.C polyeng_24.C polyeng_32.C polyeng_565.C
#
#GPORTS=Xgport.o SVGAgport.o
#POLYENGS=polyeng_8.o polyeng_555.o polyeng_24.o polyeng_32.o polyeng_565.o
#
#LDGPORTS=$(TAGL_LIB)/Xgport.o $(TAGL_LIB)/SVGAgport.o
#LDPOLYENGS=$(TAGL_LIB)/polyeng_8.o $(TAGL_LIB)/polyeng_555.o \
#           $(TAGL_LIB)/polyeng_24.o $(TAGL_LIB)/polyeng_32.o \
#           $(TAGL_LIB)/polyeng_565.o

           


# some programs will use stuff specific to a graphic port (via the Cntl() call)
# remove the graphic ports you do not use from here.

CCGPORTS=$(CCX11) $(CCSVGA) -DX_GPORT 

#
# You should not need to modify this file 
# beyond this point.
#

LDGPORT=-L$(TAGL_LIB) -ltagl $(LDGPORTS) $(LDX11) $(LDSVGA)
LDPOLYENG=$(LDPOLYENGS)

.SUFFIXES: .o .c .cc

.cc.o:
	$(CXX) -c $(CXXOPT) $(CXXMOREOPT) -I$(TAGL_INC) $<

.c.o:
	$(CC) -c $(CCOPT) $<

nothing:
	@echo make what ?

love:
	@echo Making love - do not disturb
	@echo OOOoooOOoooOOoooh
	@echo Rhahaaahaaahhhaaa

# If your compiler doesn't know the '-MM' option (generate dependancies),
# use 'makedepend' instead.
# If you don't have 'makedepend', replace it by a dummy file creation.
# I redirect stderr to /dev/null, because makedepend
# doesn't know C++ include path, and dependencies with
# my files are sufficient (I won't modify system includes ...)
# If you have defined ALL_INCLUDES properly, you can remove
# '&> /dev/null'.
#
#dep:
#	makedepend $(ALL_INCLUDES) -I$(TAGL_INC) $(SRC) &> /dev/null


dep: $(DEP)

#$(DEP): 
#	$(RM) $(DEP)
#	$(CC) -MM -I$(TAGL_INC) $(CCX11) $(CCSVGA) $(SRC) > $(DEP)


clean:
	$(RM) *.o *~ core* $(DEP)

archie:
	tar cf $(PRJ).tar `ls *.c *.C *.h Makefile README*`

