/*
 *
 * gobj.C
 *
 */

#include "gobj.h"
#include <math.h>

// Global shading attributes

int GraphicObject::_gamma_ramp[GAMMA_VALUES];

MVector GraphicObject::_L(0,0,-M_BIG);

int GraphicObject::_Lr = 0;
int GraphicObject::_Lg = 0;
int GraphicObject::_Lb = 0;

int GraphicObject::_Lc = 0;

int GraphicObject::_zoom      = 16;
int GraphicObject::_zoom_step = 4;

int GraphicObject::_width  = 0;
int GraphicObject::_height = 0;

// Destructor

GraphicObject::~GraphicObject(void)
{
}

// Pre-computations for Lighting models

void
GraphicObject::GammaRamp(gfloat gamma)
{
  int i;
  
  for(i=0; i<GAMMA_VALUES; i++)
    _gamma_ramp[i] = (int)((gfloat)M_BIG * 
			   (1.0 - exp(-(gfloat)(i << GAMMA_SHIFT) / ((gfloat)M_BIG * gamma))));
}

void 
GraphicObject::Shiny(gfloat factor, gfloat lambertian, gfloat specular)
{
  int i;

  _KD = (int)(lambertian * (gfloat)M_BIG);
  _KS = (int)(specular   * (gfloat)M_BIG);

  for(i=0; i<SPEC_VALUES; i++)
      _specular[i] = (int)((gfloat)M_BIG * 
			   pow((gfloat)i/(gfloat)SPEC_VALUES, factor));

  _flags.Set(GF_SPECULAR);
}

void
GraphicObject::Dull(void)
{
  _flags.Reset(GF_SPECULAR);
}

static class Stub
{
public:
  Stub() {GraphicObject::GammaRamp(1.0);}
} Dummy;

