
#include <iostream.h>
#include <gport.h>
#include <string.h>
#include <stdlib.h>

#ifdef X_GPORT
#include <processors/gport/Xgport.h>
#endif

extern "C" {
#include "ecran256.h"
}

GraphicPort *GP;
byte *graph_ptr;
byte *graph_mem;
byte *graph_colmap;
int   bytes_per_line;
int   graph_width;
int   graph_height;
int   direct_to_video = 0;
int   resized = 0;

void show_page(int np)
{
  if(!direct_to_video)
    GP->SwapBuffers();
  graph_mem      = GP->GraphMem();
  graph_colmap   = GP->Colormap();
  bytes_per_line = GP->BytesPerLine();

  resized = (graph_width != GP->Width()) || (graph_height != GP->Height());

  graph_width    = GP->Width();
  graph_height   = GP->Height();
}

void setcolor256(int no,byte re,byte gr,byte bl)
{
  GP->MapColor(no, re << 2, gr << 2, bl << 2);
//  GP->SwapBuffers();
}

void init256() 
{

  GP = GraphicPort::Make("Venus", 320, 200);

  if(GP->BitsPerPixel() != 8)
    {
      delete GP;
      cerr << "requires 8bpp" << endl;
      exit(1);
    }

#ifdef X_GPORT

  // keep aspect constant (Venus requires that).

  XSizeHints hint;

  hint.min_aspect.x = 320;
  hint.min_aspect.y = 200;
  hint.max_aspect.x = 320;
  hint.max_aspect.y = 200;
  hint.flags = PAspect;
  GP->Cntl(XGraphicPort::XSTDPROP, (int)&hint);
#endif

  if(getenv("GDIRECT"))
     direct_to_video = GP->SingleBuffer();

  graph_mem      = GP->GraphMem();
  graph_colmap   = GP->Colormap();
  bytes_per_line = GP->BytesPerLine();
  graph_width    = GP->Width();
  graph_height   = GP->Height();

  GP->Clear(BLACK);
  GP->SwapBuffers();
}

void fin256() 
{
  delete GP;
}



