
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <signal.h>

#define RANDOM(x) ((x) ? (random() % (x)) : (x))
#define randomize() srandom(time(NULL))


#include"ecran256.h"
#include"mouse.h"


typedef unsigned char Byte;

/* Definition de la montagne:*/
#define ntaille 7
#define taille 128  /*taille = 2^ntaille*/
#define irregularite 6

/* Stocke la montagne et la couleur associee a chaque sommet:*/
Byte tab_h[taille+1][taille+1], tab_c[taille+1][taille+1];

#define acces_h(u,v) (int)tab_h[((u) & (taille - 1))][((v) & (taille - 1))]
#define acces_c(u,v) (int)tab_c[((u) & (taille - 1))][((v) & (taille - 1))]

/* Ecran: */

#define MAX_D_MAX 64

#define MAX_W_SCREEN 1024
#define MAX_H_SCREEN 1024

#define w_screen graph_width
#define h_screen graph_height

typedef short Coord;

/* Fenetre: */
#define reduc_max 20
Byte reduction = 4;
/*
Coord tab_largeur[reduc_max], tab_hauteur[reduc_max];
Coord tab_x_orig_fen[reduc_max], tab_y_orig_fen[reduc_max];
*/

Coord largeur, hauteur;
Coord x_orig_fen, y_orig_fen;

Coord dec;              /* Distance oeil/ecran              */
Byte d_max=25;        /* Distance de vision maximale      */
Byte d_obscurite=21;  /* Distance ou commence l'obscurite */
Byte obscurite=4;
    /* on doit avoir (d_max-d_obscurite)*2^obscurite <= 64  */
#define cote 6          /* Distance entre 2 sommets         */

#define p_heigth 5    /* Hauteur du point de vue          */
#define h_lac 30        /* Niveau de l'eau                  */

/*Numeros des palettes: */
#define VENUS      1
#define TERRE      2
#define MERCURE    3
#define BROUILLARD 4
#define LSD        5
#define LUNE       6
#define TERRILS    7
#define MARS       8
#define BANQUISE   9
#define SANGUIN   10

typedef short unsigned int Fixed;
#define E(x) ((x) >> 8)                /* partie entiere   */
#define fl(x) ((x) & ((1 << 8)-1))     /* partie flottante */
#define b2F(b) ((Fixed)(b) << 8)       /* Byte -> Fixed    */
#define f2F(f) (Fixed)((f) * (1 << 8)) /* float -> Fixed   */

typedef short unsigned int FixedCoord;
#define precision 4

#define FC_E(x) (Coord)((x) >> precision)            /* partie entiere   */
#define FC_fl(x) ((x) & ((1 << precision)-1))        /* partie flottante */
#define e2FC(e) ((FixedCoord)(e) << precision)       /* entier -> Fixed    */
#define f2FC(f) (FixedCoord)((f) * (1 << precision)) /* float -> Fixed   */

/* Tables cosinus/sinus*/
Fixed cs[256], sn[256];
/* Direction de depart du point de vue: */
Byte dirZ = 0;
/* et le cosinus et le sinus:*/
Fixed xdirZ, ydirZ;

Byte dirY = 0;
Fixed xdirY, zdirY;
/* Horizon: */
Coord horizon[MAX_W_SCREEN];

/* Position du point de vue: */
Fixed up = 0, vp = 0;
Fixed hp = 0;
long vitessep = 0;

/*Flags divers: */
Byte map = 0, assembler = 1, vagues = 1;

/* Positions des etoiles: */
#define nb_etoiles 250
Coord x_etoiles[nb_etoiles], y_etoiles[nb_etoiles];

/* Numero de l'image courante; permet d'animer les vagues*/
Byte no_image = 0;

/* Initialisation d'un sommet de la montagne*/
void init_sommet(int i,int j,int altmoy,int p_taille)
 {
  int h_int;
  Byte cc;

  if (i<taille && j<taille)
  {
   if (tab_h[i][j]==0) /* nouveau sommet*/
   {
    h_int= (float)altmoy+(float)(RANDOM(p_taille*2)-(p_taille))*irregularite;
    /* Reste dans l'intervalle [1..(255-hauteur du point de vue)]:*/
    if (h_int<1)
     tab_h[i][j]=1;
    else
     if (h_int > (255-p_heigth))
      tab_h[i][j]=255-p_heigth;
     else
      tab_h[i][j]=(Byte)h_int;

    if (i<largeur && j<hauteur)
    {
     move(i + x_orig_fen, j + y_orig_fen);
     cc = tab_h[i][j];
     cc = (cc <= h_lac) ? 127 : cc >> 2;
     put_pixel(cc);
    }
   }
  }
 }

/* Initialise un carre de montagne recursivement: */
void init_mont(int i1,int j1,int p_taille)
{
 int altmoy;
 int nouvtaille;
 int i2, j2;

 i2 = i1 + p_taille;
 j2 = j1 + p_taille;

 nouvtaille = p_taille >> 1;

 altmoy =(acces_h(i1,j1) + acces_h(i2,j1)) >> 1;
 init_sommet(i1+nouvtaille,j1,altmoy,0);

 altmoy =(acces_h(i1,j1) + acces_h(i1,j2)) >> 1;
 init_sommet(i1,j1+nouvtaille,altmoy,0);

 altmoy =(acces_h(i1,j2) + acces_h(i2,j2)) >> 1;
 init_sommet(i1+nouvtaille,j2,altmoy,0);

 altmoy =(acces_h(i2,j1) + acces_h(i2,j2)) >> 1;
 init_sommet(i2,j1+nouvtaille,altmoy,0);

 altmoy= (acces_h(i1,j1) + acces_h(i2,j1)
	 + acces_h(i1,j2) + acces_h(i2,j2)) >> 2;
 init_sommet(i1+nouvtaille,j1+nouvtaille,altmoy,p_taille);

 if (p_taille>0)
 {
  init_mont(i1,j1,nouvtaille);
  init_mont(i1+nouvtaille,j1,nouvtaille);
  init_mont(i1,j1+nouvtaille,nouvtaille);
  init_mont(i1+nouvtaille,j1+nouvtaille,nouvtaille);
 }
}

void filtre()
{
 int i, j;
 int di, dj;
 float FILTRE[3][3] = {	{0.11,	0.11,	0.11},
			{0.11,	0.12,	0.11},
			{0.11,	0.11,	0.11}};

 Byte cc;
 float h_float;


 Byte tab_h_temp[taille+1][taille+1];

 for(i=0; i<taille; i++)
  for(j=0; j<taille; j++)
  {
   h_float = 0;
   for(di = 0; di < 3; di++)
    for(dj = 0; dj < 3; dj++)
     h_float += FILTRE[di][dj]*(float)acces_h(i+di-1, j+dj-1);

   if (h_float<1)
    tab_h_temp[i][j] = 1;
   else
    if (h_float > (255-p_heigth))
     tab_h_temp[i][j] = 255-p_heigth;
    else
     tab_h_temp[i][j] = (Byte)h_float;

   if (i<largeur && j<hauteur)
   {
    move(i + x_orig_fen, j + y_orig_fen);
    cc = tab_h_temp[i][j];
    cc = (cc <= h_lac) ? 127 : cc >> 2;
    put_pixel(cc);
   }
  }

 for(i=0; i<taille; i++)
  for(j=0; j<taille; j++)
   tab_h[i][j] = tab_h_temp[i][j];
}


void init_montagne_fractale()
{
  int i,j;

  for(i=0; i<taille; i++)
   for(j=0; j<taille; j++)
    tab_h[i][j]=0;

  init_sommet(0,0,2*h_lac,taille);

  init_mont(0,0,taille);

  filtre();

  for(i=0; i<taille; i++)
    for(j=0; j<taille; j++)
      if (tab_h[i][j] < h_lac)
       tab_h[i][j] = h_lac;

  for(i=0; i<taille+1; i++) tab_h[i][taille] = tab_h[i][0];
  for(i=0; i<taille+1; i++) tab_h[taille][i] = tab_h[0][i];
  tab_h[taille][taille] = tab_h[0][0];
 }

void init_mountain2()
{
 int i, j;

 for(i=0; i<taille; i++)
 {
  for(j=0; j<taille; j++)
  {
   if (((i >> 5) & 1) && ((j >> 5) & 1))
    tab_h[i][j] = 200;
   else
    tab_h[i][j] = h_lac;
  }
 }
 for(i=0; i<taille+1; i++) tab_h[i][taille] = tab_h[i][0];
 for(i=0; i<taille+1; i++) tab_h[taille][i] = tab_h[0][i];
 tab_h[taille][taille] = tab_h[0][0];
}

/* Initialisation des couleurs pour le lissage: */
void init_couleurs()
{int i,j;
 int deniv;

 for(i = 0; i < taille; i++)
 {
  for(j = 0; j < taille; j++)
  {
   if (acces_h(i,j)==h_lac) /* Un point dans le lac */
   {
    if (acces_h(i+1,j)   != h_lac ||
	acces_h(i,j+1)   != h_lac ||
	acces_h(i-1,j)   != h_lac ||
	acces_h(i,j-1)   != h_lac ||
	acces_h(i+1,j+1) != h_lac ||
	acces_h(i-1,j+1) != h_lac ||
	acces_h(i-1,j+1) != h_lac ||
	acces_h(i-1,j-1) != h_lac)
     tab_c[i][j] = 64;                /* Un point sur le bord du lac */
    else
     tab_c[i][j] = 127 - RANDOM(32);
     /*Pourquoi RANDOM(32) et pas RANDOM(63) ? Question d'esthetique...*/
   }
   else
   {
    deniv=acces_h(i-1,j)   +
	  acces_h(i,j+1)   +
	  acces_h(i-1,j+1) +
	  acces_h(i-1,j-1) -

	  acces_h(i+1,j)   -
	  acces_h(i,j-1)   -
	  acces_h(i+1,j-1) -
	  acces_h(i+1,j+1);

    deniv = deniv / 4;
    deniv = (deniv + 32);

    if (deniv > 63)
     deniv = 63;
    if (deniv < 1)
     deniv = 1;
    tab_c[i][j] = deniv;
   }
  }
 }
 for(i=0; i<taille+1; i++) tab_c[i][taille] = tab_c[i][0];
 for(i=0; i<taille+1; i++) tab_c[taille][i] = tab_c[0][i];
 tab_c[taille][taille] = tab_c[0][0];
}

typedef struct
 {
  Byte r,v,b;
 } coul;

void init_palette(Byte planete)
{
 coul ciel, montagne, lac, etoiles;
 Byte i;

 switch(planete)
 {
 case VENUS:
 {
  ciel.r     = 10; ciel.v     = 10;  ciel.b     = 0;
  montagne.r = 63; montagne.v = 63;  montagne.b = 0;
  lac.r      = 63; lac.v      = 63;  lac.b      = 63;
  etoiles.r  = 63; etoiles.v  = 63;  etoiles.b  = 0;
  break;
 }
 case TERRE:
 {
  ciel.r     = 0;  ciel.v     = 0;   ciel.b     = 10;
  montagne.r = 0;  montagne.v = 63;  montagne.b = 0;
  lac.r      = 0;  lac.v      = 0;   lac.b      = 63;
  etoiles.r  = 63; etoiles.v  = 63;  etoiles.b  = 0;
  break;
 }
 case MERCURE:
 {
  ciel.r     = 10; ciel.v     = 0;   ciel.b     = 0;
  montagne.r = 63; montagne.v = 63;  montagne.b = 63;
  lac.r      = 63; lac.v      = 0;   lac.b      = 0;
  etoiles.r  = 63; etoiles.v  = 63;  etoiles.b  = 0;
  break;
 }
 case BROUILLARD:
 {
  ciel.r     = 50; ciel.v     = 50; ciel.b      = 50;
  montagne.r = 0;  montagne.v = 0;  montagne.b  = 0;
  lac.r      = 0;  lac.v      = 0;  lac.b       = 30;
  etoiles.r  = 50; etoiles.v  = 50; etoiles.b   = 50;
  break;
 }
 case LSD:
 {
  ciel.r     = 63; ciel.v     = 0;  ciel.b      = 63;
  montagne.r = 0;  montagne.v = 63; montagne.b  = 63;
  lac.r      = 0;  lac.v      = 63; lac.b       = 0;
  etoiles.r  = 63; etoiles.v  = 0;  etoiles.b   = 0;
  break;
 }
 case LUNE:
 {
  ciel.r     = 0;  ciel.v     = 0;  ciel.b      = 0;
  montagne.r = 63; montagne.v = 63; montagne.b  = 63;
  lac.r      = 30; lac.v      = 30; lac.b       = 30;
  etoiles.r  = 63; etoiles.v  = 63; etoiles.b   = 63;
  break;
 }
 case TERRILS:
 {
  ciel.r     = 0;  ciel.v     = 0;  ciel.b      = 10;
  montagne.r = 63; montagne.v = 30; montagne.b  = 10;
  lac.r      = 10; lac.v      = 30; lac.b       = 0;
  etoiles.r  = 63; etoiles.v  = 63; etoiles.b   = 0;
  break;
 }
 case MARS:
 {
  ciel.r     = 10;  ciel.v     = 0;  ciel.b      = 0;
  montagne.r = 50; montagne.v = 15; montagne.b  = 0;
  lac.r      = 63; lac.v      = 40; lac.b       = 0;
  etoiles.r  = 0; etoiles.v  = 0; etoiles.b   = 30;
  break;
 }
 case BANQUISE:
 {
  ciel.r     = 30;  ciel.v     = 30;  ciel.b      = 63;
  montagne.r = 63;  montagne.v = 63;  montagne.b  = 63;
  lac.r      = 0;   lac.v      = 0;   lac.b       = 30;
  etoiles.r  = 30;  etoiles.v  = 30;  etoiles.b   = 63;
  break;
 }
 case SANGUIN:
 {
  ciel.r     = 0;   ciel.v     = 0;   ciel.b      = 0;
  montagne.r = 63;  montagne.v = 50;  montagne.b  = 20;
  lac.r      = 63;  lac.v      = 0;   lac.b       = 0;
  etoiles.r  = 63;  etoiles.v  = 63;  etoiles.b   = 63;
  break;
 }
 }

 setcolor256(0,0,0,0);
 for(i = 1; i < 64; i++)
 {
  setcolor256(i,(Byte) (montagne.r + (float)(ciel.r - montagne.r) * i / 64),
		(Byte) (montagne.v + (float)(ciel.v - montagne.v) * i / 64),
		(Byte) (montagne.b + (float)(ciel.b - montagne.b) * i / 64));
 }

 for(i = 0; i < 64; i++)
 {
  setcolor256(64+i,(Byte) (ciel.r + (float)(lac.r - ciel.r) * i / 64),
		   (Byte) (ciel.v + (float)(lac.v - ciel.v) * i / 64),
		   (Byte) (ciel.b + (float)(lac.b - ciel.b) * i / 64));
 }

 setcolor256(0,0,0,0);
 setcolor256(128,63,0,0);
 setcolor256(129,etoiles.r,etoiles.v,etoiles.b);
 endcolors256();
}

#define draw_assembler     \
 asm                       \
 {                         \
  push es;                 \
  push di;                 \
  push ax;                 \
  push bx;                 \
  push cx;                 \
			   \
  mov es,segment_ecran;    \
  mov di,offset_pixel;     \
  mov bx,word ptr (c_old); \
  mov ax,(pas_c_col);      \
  mov cx,word ptr (deltay);\
 }                         \
 boucle:                   \
 asm                       \
 {                         \
  mov [es:di],bh;          \
  add bx,ax;               \
  add di,80;               \
  loop boucle:;            \
			   \
  pop cx;                  \
  pop bx;                  \
  pop ax;                  \
  pop di;                  \
  pop es;                  \
 }

#define draw_c              \
 cc = c_old;                \
 for(; (deltay>0); deltay--)\
 {                          \
  c = E(cc);                \
  put_pixel(c);             \
  inc_y;                    \
  cc += pas_c_col;          \
 }


Fixed      tf[2*MAX_D_MAX+1];
Fixed     tdu[2*MAX_D_MAX+1];
Fixed   tpas1[2*MAX_D_MAX+1];
Byte tpas_col[2*MAX_D_MAX+1];

void pre_calcul()
{
 Byte dv_prime;
 float dv;

 for(dv_prime = 2; dv_prime <= (d_max * 2); dv_prime++)
  {
   dv = (float)dv_prime / 2;
   tf[dv_prime]    = f2F((float)dec / (dv * cote));
   tdu[dv_prime]   = f2F(dv*(largeur >> 1) / dec);
   tpas_col[dv_prime] = (dec/dv) + 1;
   if (tpas_col[dv_prime] <  5) tpas_col[dv_prime] =  5;
   if (tpas_col[dv_prime] > 10) tpas_col[dv_prime] = 10;
   tpas1[dv_prime]  = f2F(dv/dec);
  }
}


void aff_montagne()
{
 Byte dv, dv_prime;
 Coord hor;
 Fixed b,d;
/* Fixed A;*/
 long unsigned A;
 short B;
 Fixed * _tf;
 Fixed * _tdu;
 Fixed * _tpas1;
 Byte  * _tpas_col;
 Byte pas_col;
/* Tableaux contenant les ordonnees a l'ecran (Y) et les couleurs
  de la tranche courante:*/
 Coord tph[MAX_W_SCREEN];
 Coord *_tph;
 Fixed tpc[MAX_W_SCREEN];
 Fixed *_tpc;


/** Initialisation du niveau de l'horizon: *********************************/
 {
  Coord i;

  for(i=0; i < largeur; i++) horizon[i]=hauteur;
 }

/** Calcul la hauteur a la position de l'observateur: **********************/
/* Interpolation en divisant le carre en deux triangles: */
 {
  Byte Eup = E(up);
  Byte Evp = E(vp);
  Byte * _tab_h;
  Byte h00, h01, h10, h11;
  Byte decalh;
  Fixed h1, ph;

  Eup &= (taille-1);
  Evp &= (taille-1);
  _tab_h = &tab_h[Eup][Evp];
  if (fl(up) > fl(vp))
  {
  /* Accede aux 3 hauteurs :*/
   h00 = *_tab_h;
   _tab_h += taille+2;
   h11 = *_tab_h;
   _tab_h--;
   h10 = *_tab_h;

  /* Change les hauteurs des vagues: */

/* gloglo2 */
#define vague2(h,c) if ((h) == h_lac) {  \
   int gloglo = (c + ((decalh) << 2)) & 127; \
   (h) += (decalh & 3);  \
   (c) =  (gloglo < 128) ? (((int)sn[gloglo] >> 2) + 64) : ((256 - (int)sn[gloglo - 128]) >> 2) + 64; }  
#define vague(h) if ((h) == h_lac) (h) += (decalh & 3)
  if (vagues)
  {
   decalh  = Eup;
   decalh += Evp;
   decalh += no_image;
   vague(h00);
   decalh++;
   vague(h10);
   decalh++;
   vague(h11);
  }

   h1  = h10;
   h1 -= h00;
   h1 *= fl(up);

   ph  = h11;
   ph -= h10;
   ph *= fl(vp);

   ph += h1;
   ph += b2F(h00);
  }
  else
  {
  /* Accede aux 3 hauteurs :*/
   h00 = *_tab_h;
   _tab_h++;
   h01 = *_tab_h;
   _tab_h += taille+1;
   h11 = *_tab_h;

  /* Change les hauteurs des vagues: */
   if (vagues)
   {
    decalh  = Eup;
    decalh += Evp;
    decalh += no_image;
    vague(h00);
    decalh++;
    vague(h01);
    decalh++;
    vague(h11);
   }

   h1  = h01;
   h1 -= h00;
   h1 *= fl(vp);

   ph  = h11;
   ph -= h01;
   ph *= fl(up);

   ph += h1;
   ph += b2F(h00);
  }

/** Nivelle la hauteur du point de vue: ***********************************/
  ph += b2F(p_heigth);
  if (ph > hp) hp = ph;
 }

/**************************************************************************/
/** Coeffs pour le calcul de y: *******************************************/
/**************************************************************************/
 A = (dec * (long unsigned)hp) / cote;
 B = ((long)(short)zdirY * (long)(short)dec)/ (long)(short)xdirY;

/**************************************************************************/
/** Rotation de du et dv autour de l'axe Z: *******************************/
/**************************************************************************/
 b = ydirZ;
 d = xdirZ;

/**************************************************************************/
/** Initialisations des pointeurs sur les elements des tableaux           */
/**************************************************************************/
 _tf       =       &tf[2];
 _tdu      =      &tdu[2];
 _tpas1    =    &tpas1[2];
 _tpas_col = &tpas_col[2];

/* dv = (dv_prime + 1) / 2*/
 for(dv_prime = 2;dv_prime <= (d_max << 1); dv_prime++)
 {
/**************************************************************************/
/* Construit le tableau des ordonnees (a l'ecran) de la tranche courante: */
/**************************************************************************/
  {
   Coord i;
   Fixed u, v, f, du, pas1, pas_u, pas_v;
   Fixed pas1_u, pas1_v;
   short y0, y;
   Fixed ph, h1;
   Byte h00, h01, h10, h11;
   Byte c00, c01, c10, c11;
   Fixed pc, c1;
   Byte delta_c, lim1, lim2;
   Fixed a, c;
   Fixed cc;
   Byte Eu, Ev, decalh;
   Coord * _horizon;
   Byte *_tab_h, *_tab_c;
   FixedCoord h_old, h_new;
   Fixed c_old, c_new;


   f       = *_tf;    /* Hauteur de reference a la distance dv*/
   du      = *_tdu;   /* Decalage sur u pour la premiere colonne de l'ecran*/
   pas1    = *_tpas1;  /* Pas sur l'axe u*/
   pas_col = *_tpas_col;

  /* Ordonnee a l'ecran pour un sommet de hauteur 0.
   y = (hauteur/2) + A/dv + B */
   y0   = (hauteur >> 1) +
	  (Fixed)(A / ((long unsigned)dv_prime << 7)) + B;

  /* Incremente pour la prochaine fois: */
   _tf++; _tdu++; _tpas1++; _tpas_col++;

  /* Rotation de du et dv:*/
   a = ((long)(short)xdirZ * (long)du) >> 8;
   c = ((long)(short)ydirZ * (long)du) >> 8;

  /*Calcul u et v de depart (qui correspondent a la colonne de gauche)*/
  /* obtenus par: (u,v) = (up,vp) + R(dirZ) * (du,dv)                 */
   u  = up;  u -= a;  u -= b;
   v  = vp;  v -= c;  v += d;

  /* Incremente pour la prochaine fois: */
   b += (ydirZ >> 1);
   d += (xdirZ >> 1);

   dv = dv_prime >> 1;

  /* Gere l'obscurite: */
   if (dv > d_obscurite)
   {
    delta_c = (dv_prime << (obscurite-1))
	     - (d_obscurite << obscurite);
    lim1 = (64 - delta_c);
    lim2 = (64 + delta_c);
   }

   _tph = &tph[0];
   _tpc = &tpc[0];
   _horizon = &horizon[0];

  /* Rotation de pas par R(dirZ):      */
  /* (pas1_u,pas1_v) = R(dirZ) * (pas1,0) */
   pas1_u = ((long)(short)xdirZ * (long)pas1) >> 8;
   pas1_v = ((long)(short)ydirZ * (long)pas1) >> 8;

  /* Attention pas_col est modifie dans la boucle. */
   for(i = 0; /* arret par break*/; i+=pas_col)
   {
    pas_u = pas1_u * pas_col;
    pas_v = pas1_v * pas_col;

    Eu = E(u);
    Eu &= (taille-1);
    Ev = E(v);
    Ev &= (taille-1);

  /* Interpolation en divisant le carre en deux triangles: */
    _tab_h = &tab_h[Eu][Ev];
    _tab_c = &tab_c[Eu][Ev];

    if (fl(u) > fl(v))
    {
    /* Accede aux 3 hauteurs :*/
     h00 = *_tab_h;
     _tab_h += taille+2;
     h11 = *_tab_h;
     _tab_h--;
     h10 = *_tab_h;

     c00 = *_tab_c;
     _tab_c += taille+2;
     c11 = *_tab_c;
     _tab_c--;
     c10 = *_tab_c;

    /* Change les hauteurs des vagues: */
     if (vagues)
     {
      decalh  = Eu;
      decalh += Ev;
      decalh += no_image;
      vague2(h00,c00);
      decalh++;
      vague2(h10,c10);
      decalh++;
      vague2(h11,c11);
     }

     h1  = h10;
     h1 -= h00;
     h1 *= fl(u);

     ph  = h11;
     ph -= h10;
     ph *= fl(v);

     ph += h1;
     ph += b2F(h00);
    }
   else
   {
   /* Accede aux 3 hauteurs :*/
    h00 = *_tab_h;
    _tab_h++;
    h01 = *_tab_h;
    _tab_h += taille+1;
    h11 = *_tab_h;

    c00 = *_tab_c;
    _tab_c++;
    c01 = *_tab_c;
    _tab_c += taille+1;
    c11 = *_tab_c;

   /* Change les hauteurs des vagues: */
    if (vagues)
    {
     decalh  = Eu;
     decalh += Ev;
     decalh += no_image;
     vague2(h00,c00);
     decalh++;
     vague2(h01,c01);
     decalh++;
     vague2(h11,c11);
    }

    h1  = h01;
    h1 -= h00;
    h1 *= fl(v);

    ph  = h11;
    ph -= h01;
    ph *= fl(u);

    ph += h1;
    ph += b2F(h00);
   }

  /* Perspective sur la hauteur: */
   ph = (Fixed) (((long unsigned)ph * (long unsigned)f) >> 16);
   y  = y0 - ph;

  /* assure d'atteindre le bas de l'ecran: */
   if ((dv_prime == 2) && (y < hauteur)) y = hauteur;
   else
  /* met ph dans l'intervalle d'un Byte: */
    if (y < 0) y = 0;
    else if (y > ((unsigned)1 << (16-precision))-1)
	     y = ((unsigned)1 << (16-precision))-1;

   h_new = e2FC(y);

#define fondu(c) if ((c) < lim1) (c) += delta_c;                    \
		 else if ((c) > lim2) (c) -= delta_c; else (c) = 64;


   if (fl(u) > fl(v))
   {
    /* Change les couleurs des zones dans l'obscurite: */
    if (dv > d_obscurite)
    {
     fondu(c00);
     fondu(c10);
     fondu(c11);
    }

    c1  = c10;
    c1 -= c00;
    c1 *= fl(u);

    pc  = c11;
    pc -= c10;
    pc *= fl(v);

    pc += c1;
    pc += b2F(c00);
   }
   else
   {
    /* Change les couleurs des zones dans l'obscurite: */
    if (dv > d_obscurite)
    {
     fondu(c00);
     fondu(c01);
     fondu(c11);
    }

    c1  = c01;
    c1 -= c00;
    c1 *= fl(v);

    pc  = c11;
    pc -= c01;
    pc *= fl(u);

    pc += c1;
    pc += b2F(c00);
   }
   c_new = pc;

  /* Incremente (u,v) pour la prochaine colonne: */
   u += pas_u;
   v += pas_v;

   if (i > 0)
   {
    Fixed c2;
    Coord xc;
    Coord yc, ymax;
    Coord hor;
    short deltay, pas_c_col;
    FixedCoord pas_h;
    Fixed pas_c;
    Byte j;

    pas_h = ((long)h_new - (long)h_old) / pas_col;
    pas_c = ((long)c_new - (long)c_old) / pas_col;

    xc = i - pas_col;
    for(j = 0; j < pas_col; j++)
    {
    /* Si la tranche n'est pas la premiere qu'on calcule,
     on affiche les points entre cette tranche et la tranche precedente.*/
     if (dv_prime > 2)
     {
      yc = FC_E(h_old);
      ymax = *_tph;
      hor  = *_horizon;
      if ((yc < ymax) /* trace uniquement les segments qui montent*/
       && (yc < hor)) /* et ceux qui sont au dessus de l'horizon*/
      {
       *_horizon = yc;
       c2 = *_tpc;
       /* distance entre les 2 points de l'ecran: */
       deltay = ymax - yc;
       /* pas du shading: */
       pas_c_col =((long)c2-(long)c_old) / deltay;
	/* Le pas pour le lissage de Gouraud est calcule.
	On peut clipper le segment. Ca se resume a: */
       if (ymax > hor)
       {
	ymax = hor;
	deltay = ymax - yc;
       }

       /* Place le pointeur sur le premier point: */
       move(xc + x_orig_fen, yc + y_orig_fen);

       /* Affiche un point ...      */
       if (assembler) { draw_c } else { draw_c }
      } /* if ((yc < ymax) ... */
      xc++;
     } /* if (dv > dmin) ...*/

    *_tph = FC_E(h_old);
    *_tpc = c_old;

    _tph++;
    _tpc++;
    _horizon++;

    h_old += pas_h;
    c_old += pas_c;
    } /* for(j = 0; j < pas_col; j++) ... */
   } /* if (i > 0) ...*/
   h_old = h_new;
   c_old = c_new;

   if (i == largeur) break;
   if (i > (largeur - pas_col))
    pas_col = largeur - i;
   } /* for(i = 0; ... */
  }
/* fin construct_tables(Byte dv)                                        */
/************************************************************************/

 } /* for(dv = dmin; ... */
 {
  Coord *_horizon;
  Coord i;
  /*Efface le ciel*/
  _horizon = &horizon[0];
  for(i = 0; i<largeur; i++)
  {
   hor = *_horizon;
   if (hor>0)
   {
    move(i + x_orig_fen, y_orig_fen);
    for(; hor > 0; hor--)
    {
     put_pixel(64);
     inc_y;
    }
   }
   _horizon++;
  }
 }
}

void aff_carte()
{
 Coord i,j;
 Byte cc;

 for(i = 0; i < taille && i < largeur; i++)
 {
  move(i + x_orig_fen, y_orig_fen);
  for(j = 0; j < taille && j < hauteur; j++)
  {
   cc = tab_c[i][taille - j - 1];
   put_pixel(cc);
   inc_y;
  }
 }
 i = (E(up) & (taille - 1));
 j = ((taille - E(vp)) & (taille - 1));
 if (i < largeur && j < hauteur)
 {
  move(i + x_orig_fen, j + y_orig_fen);
  put_pixel(128);
 }
}

void init_etoiles()
{
 Byte i;

 for(i=0; i<nb_etoiles; i++)
  {
   x_etoiles[i] = RANDOM(largeur);
   y_etoiles[i] = RANDOM(hauteur);
  }
}

void aff_etoiles()
{
 Byte i;
 Coord x, y;

 for(i=0; i<nb_etoiles; i++)
  {
   x = (x_etoiles[i] + dirZ) % largeur;
   if (x < largeur)
   {
    y = (y_etoiles[i] + (dirY << 1)) % hauteur;
    if (horizon[x] > y)
    {
     move(x + x_orig_fen, y + y_orig_fen);
     put_pixel(129);
    }
   }
  }
}

void aff_logo()
{
 /* V */
 move(w_screen-11, h_screen-5); put_pixel(129);
 move(w_screen-11, h_screen-4); put_pixel(129);
 move(w_screen-11, h_screen-3); put_pixel(129);
 move(w_screen-9,  h_screen-5); put_pixel(129);
 move(w_screen-9,  h_screen-4); put_pixel(129);
 move(w_screen-9,  h_screen-3); put_pixel(129);
 move(w_screen-10, h_screen-2); put_pixel(129);
 move(w_screen-10, h_screen-3); put_pixel(129);
 move(w_screen-10, h_screen-3); put_pixel(129);

 /* L */
 move(w_screen-4, h_screen-5); put_pixel(129);
 move(w_screen-4, h_screen-4); put_pixel(129);
 move(w_screen-4, h_screen-3); put_pixel(129);
 move(w_screen-4, h_screen-2); put_pixel(129);
 move(w_screen-3, h_screen-2); put_pixel(129);
 move(w_screen-2, h_screen-2); put_pixel(129);
}

void init_cos_sin()
{
 int i;

 for(i=0; i<256; i++)
 {
  cs[i]=f2F(cos((float)i/256*2*3.14159));
  sn[i]=f2F(sin((float)i/256*2*3.14159));
 }
}

void init_reduction()
{
 largeur = w_screen - reduction * 9;
 hauteur = h_screen - reduction * 6;
 dec = 150- reduction * 4;
 x_orig_fen = (w_screen - largeur) >> 1;
 y_orig_fen = (h_screen - hauteur) >> 1;
}

void initialisations()
{
 randomize();

 init256();
 set_page(0); show_page(1);

 init_reduction();
 init_palette(BANQUISE);
 init_montagne_fractale();
/* init_mountain2();*/
 init_couleurs();
 init_etoiles();

 pre_calcul();

 init_cos_sin();

 xdirZ = cs[dirZ];
 ydirZ = sn[dirZ];

 xdirY = cs[dirY];
 zdirY = sn[dirY];
}

void main()
{
 char cc;
 Byte nopage=0;
 int idu, idv;
 short du,dv;
 long b, d;

  initialisations();

  cc=' ';
  while (cc != 'q')
  {
   set_page(nopage);
   aff_montagne();
   aff_etoiles();
   if (map) aff_carte();
   aff_logo();
   show_page(nopage);
   nopage=1 - nopage;

   no_image++;

   deplac_mouse(&idu,&idv);
   du = idu;
   dv = idv;
   du >>= 4;
   dirZ -= du;
   xdirZ = cs[dirZ];
   ydirZ = sn[dirZ];

   dv >>= 4;
   dirY += dv;
   if (dirY > 40 && dirY < 128) dirY = 40;
   else
    if (dirY < 216 && dirY >= 128) dirY = 216;


   xdirY = cs[dirY];
   zdirY = sn[dirY];

   b = ((long)(short)ydirZ * vitessep);
   b = (b * (long)(short)xdirY) >> 16;

   d = ((long)(short)xdirZ * vitessep);
   d = (d * (long)(short)xdirY) >> 16;

   up = up - (short)b;
   vp = vp + (short)d;

   hp = hp + (((long)(short)zdirY*(long)(short)vitessep) >> 6);

   if(resized)
     {
       clr_page;
       init_reduction();
       pre_calcul();
       init_etoiles();
     }

   if ((cc = readkbd()))
   {
    switch(cc)
     {
      case 'v':vagues    = 1 - vagues;    break;
      case 'm':map       = 1 - map;       break;
      case 'a':assembler = 1 - assembler; break;
      case '1':init_palette(VENUS);       break;
      case '2':init_palette(TERRE);       break;
      case '3':init_palette(MERCURE);     break;
      case '4':init_palette(BROUILLARD);  break;
      case '5':init_palette(LSD);         break;
      case '6':init_palette(TERRILS);     break;
      case '7':init_palette(LUNE);        break;
      case '8':init_palette(MARS);        break;
      case '9':init_palette(BANQUISE);    break;
      case '0':init_palette(SANGUIN);     break;
      case '+':
      {
       if (reduction > 0)
       {
	reduction--;
	init_reduction();
	pre_calcul();
	init_etoiles();
       }
       break;
      }
      case '-':
      {
       if (reduction < (reduc_max-1))
       {
	reduction++;
	init_reduction();
	pre_calcul();
	init_etoiles();

	set_page(nopage);
	clr_page;
	aff_montagne();
	aff_etoiles();
	if (map) aff_carte();
	aff_logo();
	show_page(nopage);
	nopage=1 - nopage;
	set_page(nopage);
	clr_page;
       }
       break;
      }
      case '*':
      {
       vitessep += 80;
       break;
      }
      case '/':
      {
       vitessep -= 80;
       break;
      }
      case ' ':
      {
       vitessep = 0;
       break;
      }
      case 'r':
      {
       randomize();
       init_montagne_fractale();
       init_couleurs();
       break;
      }
      case 'w':
      {
       if(d_max < 63)
	 {
         d_max++;
         d_obscurite++;
         pre_calcul();
         }
       break;
      }
      case 'x':
      {
       if(d_max > 5)
         {
         d_max--;
         d_obscurite--;
         pre_calcul();
         }
       break;
      } 
      case 's':
      {
       if(obscurite < 5)
	 {
         obscurite++;
         d_obscurite = d_max - (d_max - d_obscurite) / 2;
         }
       break;
      }
      case 'd':
      {
       if(obscurite > 2)
         {
         obscurite--;
         d_obscurite = d_max - (d_max - d_obscurite) * 2;
         }
       break;
      }
     }
   }
  }
 fin256();
}
