/*
 *
 * TAGL driver for povray
 *
 */

#include "gport.h"
#include "polyeng.h"
#include "processors/gport/Xgport.h"

extern "C"
{
void display_finished(void);
void display_init(int width, int height);
void display_close(void);
void display_plot(int x, int y, unsigned char R,
				unsigned char G,
				unsigned char B);

void unix_init_POVRAY(void);
}

#include <iostream.h>
#include <stdlib.h>

GraphicPort   *GP;
PolygonEngine *PE;

static int _direct = 0;

void unix_init_POVRAY(void)
{
}

void display_finished()
{
}

void display_init(int width, int height)
{
  GP = GraphicPort::Make("POVRAY", width, height);
  if(!GP)
     {
       cerr << "could not open graphic port\n";
       exit(-1);
     }
  GP->Cntl(XGraphicPort::RESIZE,0);
  GP->RGBMode();
  _direct = GP->SingleBuffer();

  PE = PolygonEngine::Make(GP);
  if(!PE)
    {
      cerr << "could not create polygon engine\n";
      exit(-1);
    }
  
  PE->RGBMode();
  PE->Dither(1);

}

void display_close(void)
{
   char q = 0;

   if(!_direct)
      GP->SwapBuffers();

   while(q != 'q')
      {
	while(!(q = GP->GetKey()));
	if(!_direct)
           GP->SwapBuffers();
      }


   delete PE;
   delete GP;
}

void display_plot(int x, int y, 
                  unsigned char R, unsigned char G, unsigned char B)
{
  PE->SetPixel(x,y,R,G,B);

  if(!_direct && !x && !(y % 10))	
     GP->SwapBuffers();
}
