/*
 *
 * gdefs.h
 *
 */

#ifndef GDEFS_H
#define GDEFS_H

#include <assert.h>
#include <iostream.h>
#include <stdio.h>
#include "flags.h"

const int  GP_COLORMAP_SZ = 256;

typedef int            ScrCoord;       // coordinates in screen space
typedef unsigned char  ColorIndex;     // used by colormap  displays
typedef long           ColorCode;      // used by truecolor displays
typedef unsigned long  UColorCode;     // unsigned color code
typedef unsigned short ZCoord;         // type of a ZBuffer cell
typedef long           SZCoord;        // used to compute ZBuffer values
typedef int            TexCoord;       // coordinates in texture space
typedef int            ColorComponent; // value of R, G, or B

typedef char          Point; // dummy - will be a class later on

const int VF_NONE = 0;
const int VF_CLIP = 1;

class GVertex
{
 public:
  ScrCoord       x,y;
  SZCoord        z;
  ColorCode      c;
  ColorComponent r,g,b,a;
  TexCoord       X,Y;

  Point          geometry;

  Flags          flags;
};


inline ostream& operator<<(ostream& o, GVertex& v)
{
  return o << "[" << v.x << " " << v.y << " " << v.z << "]\n";
};

class GVertexAttributes
{
 public:
  ZCoord         z;
  ColorCode      c;
  ColorComponent r,g,b,a;
  TexCoord       X,Y;
};

const int VC_ENTRIES = 50;

inline void printb(UColorCode x)
{
  int shift;

  for(shift = 31; shift >= 0; shift--)
    fprintf(stderr,x & (((UColorCode)1) << shift) ? "1" : "0");
}

inline int firstbit(UColorCode x)
{
  int cnt;

  for(cnt=0; (cnt < 32) && !(x & (((UColorCode)1) << cnt)); cnt++);

  return cnt;
}

inline int nbrbits(UColorCode x)
{
  int cnt = 0, shift;

  for(shift = 0; shift < 32; shift++)
    if(x & (((UColorCode)1) << shift))
      cnt++;

  return cnt;
}


#endif

